﻿#pragma once
#include <cstdint>

enum class ErrorCode : uint32_t
{
	UNKNOWN_ERROR = 0,

	// Generic
	UNCOVERED_ENUM_VALUE,
	OUT_OF_BOUNDS,
	INVALID_ARGUMENT,
	ILLEGAL_OBJECT_STATE,
	NOT_ENOUGH_DATA,

	// Library
	FAILED_LIBRARY_LOAD,
	FAILED_LIBRARY_GET,

	// Events
	FAILED_EVENT_OPEN,
	FAILED_EVENT_CREATE,
	FAILED_EVENT_SET,
	FAILED_EVENT_UNSET,
	FAILED_WAIT,
	WAIT_TIMED_OUT,

	// Mutex
	FAILED_MUTEX_CREATE,
	FAILED_MUTEX_ACQUIRE,
	MUTEX_ALREADY_TAKEN,

	// Thread
	FAILED_THREAD_CREATE,
};
